%global with_doc %{!?_without_doc:1}%{?_without_doc:0}
%global with_trans %{!?_without_trans:1}%{?_without_trans:0}

%global release_name liberty
%global service nova

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:             openstack-nova
# Liberty semver reset
# https://review.openstack.org/#/q/I6a35fa0dda798fad93b804d00a46af80f08d475c,n,z
Epoch:            1
Version:          12.0.6
Release:          15%{?dist}
Summary:          OpenStack Compute (nova)

License:          ASL 2.0
URL:              http://openstack.org/projects/compute/
Source0:          http://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz

#
# patches_ignore=DROP-IN-RPM
#

#
# patches_base=+1
#
Patch0001: 0001-Revert-Store-correct-VirtCPUTopology.patch
Patch0002: 0002-hardware-stop-using-instance-cell-topology-in-CPU-pi.patch
Patch0003: 0003-Fix-CPU-pinning-for-odd-number-of-CPUs-w-hyperthread.patch
Patch0004: 0004-libvirt-verify-cpu-bw-policy-capability-for-host.patch
Patch0005: 0005-hardware-improve-parse_cpu_spec-to-handle-exclusion-.patch
Patch0006: 0006-libvirt-rework-membacking-config-to-support-future-f.patch
Patch0007: 0007-libvirt-add-cpu-schedular-priority-config.patch
Patch0008: 0008-virt-add-constraint-to-handle-realtime-policy.patch
Patch0009: 0009-libvirt-add-realtime-support.patch
Patch0010: 0010-hardware-check-whether-realtime-capable-in-API.patch
Patch0011: 0011-virt-reserved-hugepages-on-compute-host.patch
Patch0012: 0012-Revert-virt-reserved-hugepages-on-compute-host.patch
Patch0013: 0013-rbd-use-rbd-snapshots-and-cloning-for-ephemeral-disk.patch
Patch0014: 0014-network-make-nova-to-handle-port_security_enabled-Fa.patch
Patch0015: 0015-network-Fix-nova-boot-with-multiple-security-groups.patch
Patch0016: 0016-libvirt-release-serial-console-ports-when-destroying.patch
Patch0017: 0017-Compute-API-omit-disk-container-formats-when-creatin.patch
Patch0018: 0018-VMware-Use-Port-Group-and-Key-in-binding-details.patch
Patch0019: 0019-Fix-migration-query-with-unicode-status.patch
Patch0020: 0020-SR-IOV-Improve-the-vnic-type-check-in-the-neutron-ap.patch
Patch0021: 0021-Clean-up-networks-with-SR-IOV-binding-on-reschedule.patch
Patch0022: 0022-Ironic-Workaround-to-mitigate-bug-1341420.patch
Patch0023: 0023-libvirt-fix-serial-ports-lost-after-hard-reboot.patch
Patch0024: 0024-SameHostFilter-should-fail-if-host-does-not-have-ins.patch
Patch0025: 0025-scheduler-quick-fail-on-CPUs-pinning-conflicts-durin.patch
Patch0026: 0026-add-reserved-huge-pages-size-capability.patch
Patch0027: 0027-Fix-multipath-iSCSI-encrypted-volume-attach-failure.patch
Patch0028: 0028-compute-Skip-driver-detach-calls-for-non-local-insta.patch
Patch0029: 0029-network-handle-unauthorized-exception-from-neutron.patch
Patch0030: 0030-NUMATopologyFilter-raise-exception-and-not-continue-.patch
Patch0031: 0031-Only-attempt-to-inject-files-if-the-injection-disk-e.patch
Patch0032: 0032-Remove-fake_imagebackend.Raw-and-cleanup-dependent-t.patch
Patch0033: 0033-libvirt-Fix-content-of-disk.config-lost-after-migrat.patch
Patch0034: 0034-Don-t-overwrite-config-disk-when-using-Rbd.patch
Patch0035: 0035-Remove-paramiko-dependency.patch
Patch0036: 0036-libvirt-use-native-AIO-mode-for-image-backends.patch
Patch0037: 0037-libvirt-use-native-AIO-mode-for-cinder-volumes.patch
Patch0038: 0038-Do-not-try-to-backport-when-db-has-older-object-vers.patch
Patch0039: 0039-libvirt-fix-DiskSmallerThanImage-when-block-migrate-.patch
Patch0040: 0040-Send-events-to-all-relevant-hosts-if-migrating.patch
Patch0041: 0041-Create-image-for-suspended-instance-booted-from-volu.patch
Patch0042: 0042-libvirt-Split-out-resize_image-logic-from-create_ima.patch
Patch0043: 0043-libvirt-fix-incorrect-host-cpus-giving-to-emulator-t.patch
Patch0044: 0044-libvirt-fix-serial-console-not-correctly-defined-aft.patch
Patch0045: 0045-Cleanup-after-any-failed-libvirt-spawn.patch
Patch0046: 0046-Completed-migrations-are-not-in-progress.patch
Patch0047: 0047-Add-uuidsentinel-test-module.patch
Patch0048: 0048-Use-stashed-volume-connector-in-_local_cleanup_bdm_v.patch
Patch0049: 0049-libvirt-avoid-generating-script-with-empty-path.patch
Patch0050: 0050-libvirt-Limit-destroying-disks-during-cleanup-to-spa.patch
Patch0051: 0051-libvirt-workaround-findmnt-behaviour-change.patch
Patch0052: 0052-libvirt-set-vlan-tag-for-macvtap-on-SR-IOV-VFs.patch
Patch0053: 0053-compute-Remove-instance.uuid-from-detach-call-during.patch
Patch0054: 0054-migration-volume-failed-for-invalid-type.patch
Patch0055: 0055-libvirt-remove-version-checks-for-block-job-handling.patch
Patch0056: 0056-Fix-race-condition-bug-during-live_snapshot.patch
Patch0057: 0057-libvirt-Fix-BlockDevice.wait_for_job-when-qemu-repor.patch
Patch0058: 0058-libvirt-Mock-is_job_complete-in-test_driver.patch
Patch0059: 0059-libvirt-Use-the-mirror-element-to-detect-job-complet.patch
Patch0060: 0060-After-migrate-in-use-volume-the-BDM-information-lost.patch
Patch0061: 0061-libvirt-Remove-redundant-bdm-serial-mangling-and-sav.patch
Patch0062: 0062-Don-t-apply-multi-queue-to-SRIOV-ports.patch
Patch0063: 0063-testfix-unable-to-unshelve-instances.patch
Patch0064: 0064-Fix-wait-for-detach-code-to-handle-disk-not-found-er.patch
Patch0065: 0065-Raise-DeviceNotFound-detaching-volume-from-persisten.patch

Source1:          nova-dist.conf
Source6:          nova.logrotate

Source10:         openstack-nova-api.service
Source11:         openstack-nova-cert.service
Source12:         openstack-nova-compute.service
Source13:         openstack-nova-network.service
Source14:         openstack-nova-objectstore.service
Source15:         openstack-nova-scheduler.service
Source18:         openstack-nova-xvpvncproxy.service
Source19:         openstack-nova-console.service
Source20:         openstack-nova-consoleauth.service
Source25:         openstack-nova-metadata-api.service
Source26:         openstack-nova-conductor.service
Source27:         openstack-nova-cells.service
Source28:         openstack-nova-spicehtml5proxy.service
Source29:         openstack-nova-novncproxy.service
Source31:         openstack-nova-serialproxy.service

Source21:         nova-polkit.pkla
Source23:         nova-polkit.rules
Source22:         nova-ifc-template
Source24:         nova-sudoers
Source30:         openstack-nova-novncproxy.sysconfig

Source35:         nova_migration-sudoers
Source36:         nova-ssh-config
Source37:         nova-migration-wrapper
Source38:         nova_migration_identity
Source39:         nova_migration_authorized_keys
Source40:         nova_migration-rootwrap.conf
Source41:         nova_migration-rootwrap_cold_migration

BuildArch:        noarch
BuildRequires:    intltool
BuildRequires:    python2-devel
BuildRequires:    python-sphinx
BuildRequires:    python-oslo-sphinx
BuildRequires:    python-setuptools
BuildRequires:    python-netaddr
BuildRequires:    python-pbr
BuildRequires:    python-d2to1
BuildRequires:    python-six
BuildRequires:    python-oslo-i18n

Requires:         openstack-nova-compute = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-cert = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-scheduler = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-api = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-network = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-objectstore = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-conductor = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-console = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-cells = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-novncproxy = %{epoch}:%{version}-%{release}
Requires:         openstack-nova-migration = %{epoch}:%{version}-%{release}


%description
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

%package common
Summary:          Components common to all OpenStack Nova services
Group:            Applications/System

Requires:         python-nova = %{epoch}:%{version}-%{release}
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
Requires(pre):    shadow-utils
BuildRequires:    systemd
# Required to build nova.conf.sample
BuildRequires:    python-keystonemiddleware
BuildRequires:    python-oslo-service
BuildRequires:    python-cryptography >= 1.0


%description common
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains scripts, config and dependencies shared
between all the OpenStack nova services.


%package compute
Summary:          OpenStack Nova Virtual Machine control service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         curl
Requires:         iscsi-initiator-utils
Requires:         iptables iptables-ipv6
Requires:         ipmitool
Requires:         python-libguestfs
Requires:         libvirt-python
Requires:         libvirt-daemon-kvm
%if 0%{?rhel}==0
Requires:         libvirt-daemon-lxc
%endif
Requires:         openssh-clients
Requires:         rsync
Requires:         lvm2
Requires:         python-cinderclient >= 1.3.1
Requires(pre):    qemu-kvm
Requires:         genisoimage
Requires:         bridge-utils
Requires:         sg3_utils
Requires:         sysfsutils

%description compute
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service for controlling Virtual Machines.


%package network
Summary:          OpenStack Nova Network control service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         radvd
Requires:         bridge-utils
Requires:         dnsmasq
Requires:         dnsmasq-utils
Requires:         ebtables
Requires:         conntrack-tools

%description network
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service for controlling networking.


%package scheduler
Summary:          OpenStack Nova VM distribution service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description scheduler
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the service for scheduling where
to run Virtual Machines in the cloud.


%package cert
Summary:          OpenStack Nova certificate management service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description cert
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service for managing certificates.


%package api
Summary:          OpenStack Nova API services
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-cinderclient >= 1.3.1

%description api
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing programmatic access.

%package conductor
Summary:          OpenStack Nova Conductor services
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description conductor
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing database access for
the compute service

%package objectstore
Summary:          OpenStack Nova simple object store service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description objectstore
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova service providing a simple object store.


%package console
Summary:          OpenStack Nova console access services
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-websockify

%description console
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing
console access services to Virtual Machines.

%package cells
Summary:          OpenStack Nova Cells services
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}

%description cells
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova Cells service providing additional
scaling and (geographic) distribution for compute services.

%package novncproxy
Summary:          OpenStack Nova noVNC proxy service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         novnc
Requires:         python-websockify


%description novncproxy
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova noVNC Proxy service that can proxy
VNC traffic over browser websockets connections.

%package spicehtml5proxy
Summary:          OpenStack Nova Spice HTML5 console access service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-websockify

%description spicehtml5proxy
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing the
spice HTML5 console access service to Virtual Machines.

%package serialproxy
Summary:          OpenStack Nova serial console access service
Group:            Applications/System

Requires:         openstack-nova-common = %{epoch}:%{version}-%{release}
Requires:         python-websockify

%description serialproxy
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains the Nova services providing the
serial console access service to Virtual Machines.

%package migration
Summary:          OpenStack Nova Migration

Requires:         openstack-nova-compute = %{epoch}:%{version}-%{release}

%description migration
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform. It gives you the
software, control panels, and APIs required to orchestrate a cloud,
including running instances, managing networks, and controlling access
through users and projects. OpenStack Compute strives to be both
hardware and hypervisor agnostic, currently supporting a variety of
standard hardware configurations and seven major hypervisors.

This package contains scripts and config to support VM migration in Nova.

%package -n       python-nova
Summary:          Nova Python libraries
Group:            Applications/System

Requires:         openssl
# Require openssh for ssh-keygen
Requires:         openssh
Requires:         sudo

Requires:         python-paramiko

Requires:         python-eventlet >= 0.17.4
Requires:         python-iso8601
Requires:         python-netaddr
Requires:         python-lxml
Requires:         python-anyjson
Requires:         python-boto
Requires:         python-cheetah
Requires:         python-ldap
Requires:         python-stevedore >= 1.5.0

Requires:         python-memcached

Requires:         python-sqlalchemy >= 0.9.9
Requires:         python-migrate >= 0.9.6
Requires:         python-alembic >= 0.8.0

Requires:         python-paste-deploy
Requires:         python-routes
Requires:         python-webob

Requires:         python-babel
Requires:         python-cryptography >= 1.0
Requires:         python-glanceclient >= 0.18.0
Requires:         python-keystonemiddleware >= 2.0.0
Requires:         python-jinja2
Requires:         python-jsonschema
Requires:         python-neutronclient >= 2.6.0
Requires:         python-novaclient >= 2.30.1
Requires:         python-os-brick
Requires:         python-oslo-concurrency >= 2.3.0
Requires:         python-oslo-config >= 2:2.3.0
Requires:         python-oslo-context >= 0.2.0
Requires:         python-oslo-db >= 2.4.1
Requires:         python-oslo-i18n >= 1.5.0
Requires:         python-oslo-log >= 1.8.0
Requires:         python-oslo-messaging >= 2.5.0
Requires:         python-oslo-middleware >= 2.8.0
Requires:         python-oslo-reports >= 0.1.0
Requires:         python-oslo-rootwrap >= 2.0.0
Requires:         python-oslo-serialization >= 1.4.0
Requires:         python-oslo-service >= 0.7.0
Requires:         python-oslo-utils >= 2.0.0
Requires:         python-oslo-versionedobjects >= 0.9.0
Requires:         python-oslo-vmware >= 1.16.0
Requires:         python-pbr
Requires:         python-posix_ipc
Requires:         python-psutil
Requires:         python-rfc3986
Requires:         python-six >= 1.9.0

%description -n   python-nova
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform.

This package contains the nova Python library.

%if 0%{?with_doc}
%package doc
Summary:          Documentation for OpenStack Compute
Group:            Documentation

BuildRequires:    graphviz

# Required to build module documents
BuildRequires:    python-boto
BuildRequires:    python-eventlet
BuildRequires:    python-barbicanclient
BuildRequires:    python-cinderclient
BuildRequires:    python-glanceclient
BuildRequires:    python-keystoneclient
BuildRequires:    python-neutronclient
BuildRequires:    python-lxml
BuildRequires:    python-os-brick
BuildRequires:    python-oslo-config
BuildRequires:    python-oslo-db
BuildRequires:    python-oslo-log
BuildRequires:    python-oslo-messaging
BuildRequires:    python-oslo-reports
BuildRequires:    python-oslo-utils
BuildRequires:    python-oslo-versionedobjects
BuildRequires:    python-oslo-vmware
BuildRequires:    python-paramiko
BuildRequires:    python-redis
BuildRequires:    python-rfc3986
BuildRequires:    python-routes
BuildRequires:    python-sqlalchemy
BuildRequires:    python-webob
BuildRequires:    python-websockify
BuildRequires:    python-zmq
# while not strictly required, quiets the build down when building docs.
BuildRequires:    python-migrate, python-iso8601

%description      doc
OpenStack Compute (codename Nova) is open source software designed to
provision and manage large networks of virtual machines, creating a
redundant and scalable cloud computing platform.

This package contains documentation files for nova.
%endif

%prep
%setup -q -n nova-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1
%patch0028 -p1
%patch0029 -p1
%patch0030 -p1
%patch0031 -p1
%patch0032 -p1
%patch0033 -p1
%patch0034 -p1
%patch0035 -p1
%patch0036 -p1
%patch0037 -p1
%patch0038 -p1
%patch0039 -p1
%patch0040 -p1
%patch0041 -p1
%patch0042 -p1
%patch0043 -p1
%patch0044 -p1
%patch0045 -p1
%patch0046 -p1
%patch0047 -p1
%patch0048 -p1
%patch0049 -p1
%patch0050 -p1
%patch0051 -p1
%patch0052 -p1
%patch0053 -p1
%patch0054 -p1
%patch0055 -p1
%patch0056 -p1
%patch0057 -p1
%patch0058 -p1
%patch0059 -p1
%patch0060 -p1
%patch0061 -p1
%patch0062 -p1
%patch0063 -p1
%patch0064 -p1
%patch0065 -p1

find . \( -name .gitignore -o -name .placeholder \) -delete

find nova -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Remove the requirements file so that pbr hooks don't add it
# to distutils requiers_dist config
rm -rf {test-,}requirements.txt tools/{pip,test}-requires

# remove unnecessary .po/.pot files
find nova/locale \( -name '*.po' -o -name '*.pot' \) -delete

%build
PYTHONPATH=. oslo-config-generator --config-file=etc/nova/nova-config-generator.conf

%{__python2} setup.py build

# Avoid http://bugzilla.redhat.com/1059815. Remove when that is closed
sed -i 's|group/name|group;name|; s|\[DEFAULT\]/|DEFAULT;|' etc/nova/nova.conf.sample

# Programmatically update defaults in sample config
# which is installed at /etc/nova/nova.conf

#  First we ensure all values are commented in appropriate format.
#  Since icehouse, there was an uncommented keystone_authtoken section
#  at the end of the file which mimics but also conflicted with our
#  distro editing that had been done for many releases.
sed -i '/^[^#[]/{s/^/#/; s/ //g}; /^#[^ ]/s/ = /=/' etc/nova/nova.conf.sample

#  TODO: Make this more robust
#  Note it only edits the first occurance, so assumes a section ordering in sample
#  and also doesn't support multi-valued variables like dhcpbridge_flagfile.
while read name eq value; do
  test "$name" && test "$value" || continue
  sed -i "0,/^# *$name=/{s!^# *$name=.*!#$name=$value!}" etc/nova/nova.conf.sample
done < %{SOURCE1}

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# docs generation requires everything to be installed first
export PYTHONPATH="$( pwd ):$PYTHONPATH"

pushd doc

# Remove this once sphinxcontrib.seqdiag becomes available
sed -i -e '/sphinxcontrib.seqdiag/d' source/conf.py

%if 0%{?with_doc}
SPHINX_DEBUG=1 sphinx-build -b html source build/html
# Fix hidden-file-or-dir warnings
rm -fr build/html/.doctrees build/html/.buildinfo
%endif

# Create dir link to avoid a sphinx-build exception
mkdir -p build/man/.doctrees/
ln -s .  build/man/.doctrees/man
SPHINX_DEBUG=1 sphinx-build -b man -c source source/man build/man
mkdir -p %{buildroot}%{_mandir}/man1
install -p -D -m 644 build/man/*.1 %{buildroot}%{_mandir}/man1/

popd

# Setup directories
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/buckets
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/instances
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/keys
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/networks
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/tmp
install -d -m 750 %{buildroot}%{_localstatedir}/log/nova
install -d -m 700 %{buildroot}%{_sharedstatedir}/nova/.ssh

# Setup ghost CA cert
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/CA
install -p -m 755 nova/CA/*.sh %{buildroot}%{_sharedstatedir}/nova/CA
install -p -m 644 nova/CA/openssl.cnf.tmpl %{buildroot}%{_sharedstatedir}/nova/CA
install -d -m 755 %{buildroot}%{_sharedstatedir}/nova/CA/{certs,crl,newcerts,projects,reqs}
touch %{buildroot}%{_sharedstatedir}/nova/CA/{cacert.pem,crl.pem,index.txt,openssl.cnf,serial}
install -d -m 750 %{buildroot}%{_sharedstatedir}/nova/CA/private
touch %{buildroot}%{_sharedstatedir}/nova/CA/private/cakey.pem

# Install config files
install -d -m 755 %{buildroot}%{_sysconfdir}/nova
install -p -D -m 640 %{SOURCE1} %{buildroot}%{_datadir}/nova/nova-dist.conf
install -p -D -m 640 etc/nova/nova.conf.sample  %{buildroot}%{_sysconfdir}/nova/nova.conf
install -p -D -m 640 etc/nova/rootwrap.conf %{buildroot}%{_sysconfdir}/nova/rootwrap.conf
install -p -D -m 640 etc/nova/api-paste.ini %{buildroot}%{_sysconfdir}/nova/api-paste.ini
install -p -D -m 640 etc/nova/policy.json %{buildroot}%{_sysconfdir}/nova/policy.json
install -d -m 755 %{buildroot}%{_sysconfdir}/nova/migration
install -p -D -m 600 %{SOURCE38} %{buildroot}%{_sysconfdir}/nova/migration/identity
install -p -D -m 644 %{SOURCE39} %{buildroot}%{_sysconfdir}/nova/migration/authorized_keys
install -p -D -m 640 %{SOURCE40} %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.conf
install -d -m 755 %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.d
install -p -D -m 640 %{SOURCE41} %{buildroot}%{_sysconfdir}/nova/migration/rootwrap.d/cold_migration.filters

# Install version info file
cat > %{buildroot}%{_sysconfdir}/nova/release <<EOF
[Nova]
vendor = Red Hat
product = OpenStack Compute
package = %{release}
EOF

# Install initscripts for Nova services
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/openstack-nova-api.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/openstack-nova-cert.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/openstack-nova-compute.service
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/openstack-nova-network.service
install -p -D -m 644 %{SOURCE14} %{buildroot}%{_unitdir}/openstack-nova-objectstore.service
install -p -D -m 644 %{SOURCE15} %{buildroot}%{_unitdir}/openstack-nova-scheduler.service
install -p -D -m 644 %{SOURCE18} %{buildroot}%{_unitdir}/openstack-nova-xvpvncproxy.service
install -p -D -m 644 %{SOURCE19} %{buildroot}%{_unitdir}/openstack-nova-console.service
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_unitdir}/openstack-nova-consoleauth.service
install -p -D -m 644 %{SOURCE25} %{buildroot}%{_unitdir}/openstack-nova-metadata-api.service
install -p -D -m 644 %{SOURCE26} %{buildroot}%{_unitdir}/openstack-nova-conductor.service
install -p -D -m 644 %{SOURCE27} %{buildroot}%{_unitdir}/openstack-nova-cells.service
install -p -D -m 644 %{SOURCE28} %{buildroot}%{_unitdir}/openstack-nova-spicehtml5proxy.service
install -p -D -m 644 %{SOURCE29} %{buildroot}%{_unitdir}/openstack-nova-novncproxy.service
install -p -D -m 644 %{SOURCE31} %{buildroot}%{_unitdir}/openstack-nova-serialproxy.service

# Install sudoers
install -p -D -m 440 %{SOURCE24} %{buildroot}%{_sysconfdir}/sudoers.d/nova
install -p -D -m 440 %{SOURCE35} %{buildroot}%{_sysconfdir}/sudoers.d/nova_migration

# Install nova ssh client config for migration
install -p -D -m 600 %{SOURCE36} %{buildroot}%{_sharedstatedir}/nova/.ssh/config

# Install nova migration ssh wrapper command
install -p -D -m 755 %{SOURCE37} %{buildroot}%{_bindir}/nova-migration-wrapper

# Install logrotate
install -p -D -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-nova

# Install pid directory
install -d -m 755 %{buildroot}%{_localstatedir}/run/nova

# Install template files
install -p -D -m 644 nova/cloudpipe/client.ovpn.template %{buildroot}%{_datarootdir}/nova/client.ovpn.template
install -p -D -m 644 %{SOURCE22} %{buildroot}%{_datarootdir}/nova/interfaces.template

# Install rootwrap files in /usr/share/nova/rootwrap
mkdir -p %{buildroot}%{_datarootdir}/nova/rootwrap/
install -p -D -m 644 etc/nova/rootwrap.d/* %{buildroot}%{_datarootdir}/nova/rootwrap/

# Older format. Remove when we no longer want to support Fedora 17 with master branch packages
install -d -m 755 %{buildroot}%{_sysconfdir}/polkit-1/localauthority/50-local.d
install -p -D -m 644 %{SOURCE21} %{buildroot}%{_sysconfdir}/polkit-1/localauthority/50-local.d/50-nova.pkla
# Newer format since Fedora 18
install -d -m 755 %{buildroot}%{_sysconfdir}/polkit-1/rules.d
install -p -D -m 644 %{SOURCE23} %{buildroot}%{_sysconfdir}/polkit-1/rules.d/50-nova.rules

# Install novncproxy service options template
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -p -m 0644 %{SOURCE30} %{buildroot}%{_sysconfdir}/sysconfig/openstack-nova-novncproxy

# Remove unneeded in production stuff
rm -f %{buildroot}%{_bindir}/nova-debug
rm -fr %{buildroot}%{python2_sitelib}/nova/tests/
rm -fr %{buildroot}%{python2_sitelib}/run_tests.*
rm -f %{buildroot}%{_bindir}/nova-combined
rm -f %{buildroot}/usr/share/doc/nova/README*

%pre common
getent group nova >/dev/null || groupadd -r nova --gid 162
if ! getent passwd nova >/dev/null; then
  useradd -u 162 -r -g nova -G nova,nobody -d %{_sharedstatedir}/nova -s /sbin/nologin -c "OpenStack Nova Daemons" nova
fi
exit 0

%pre compute
usermod -a -G qemu nova
%pre migration
getent group nova_migration >/dev/null || groupadd -r nova_migration
getent passwd nova_migration >/dev/null || \
    useradd -r -g nova_migration -d / -s /bin/bash -c "OpenStack Nova Migration" nova_migration
exit 0

%post compute
%systemd_post %{name}-compute.service
%post network
%systemd_post %{name}-network.service
%post scheduler
%systemd_post %{name}-scheduler.service
%post cert
%systemd_post %{name}-cert.service
%post api
%systemd_post %{name}-api.service %{name}-metadata-api.service
%post conductor
%systemd_post %{name}-conductor.service
%post objectstore
%systemd_post %{name}-objectstore.service
%post console
%systemd_post %{name}-console.service %{name}-consoleauth.service %{name}-xvpvncproxy.service
%post cells
%systemd_post %{name}-cells.service
%post novncproxy
%systemd_post %{name}-novncproxy.service
%post spicehtml5proxy
%systemd_post %{name}-spicehtml5proxy.service
%post serialproxy
%systemd_post %{name}-serialproxy.service

%preun compute
%systemd_preun %{name}-compute.service
%preun network
%systemd_preun %{name}-network.service
%preun scheduler
%systemd_preun %{name}-scheduler.service
%preun cert
%systemd_preun %{name}-cert.service
%preun api
%systemd_preun %{name}-api.service %{name}-metadata-api.service
%preun objectstore
%systemd_preun %{name}-objectstore.service
%preun conductor
%systemd_preun %{name}-conductor.service
%preun console
%systemd_preun %{name}-console.service %{name}-consoleauth.service %{name}-xvpvncproxy.service
%preun cells
%systemd_preun %{name}-cells.service
%preun novncproxy
%systemd_preun %{name}-novncproxy.service
%preun spicehtml5proxy
%systemd_preun %{name}-spicehtml5proxy.service
%preun serialproxy
%systemd_preun %{name}-serialproxy.service

%postun compute
%systemd_postun_with_restart %{name}-compute.service
%postun network
%systemd_postun_with_restart %{name}-network.service
%postun scheduler
%systemd_postun_with_restart %{name}-scheduler.service
%postun cert
%systemd_postun_with_restart %{name}-cert.service
%postun api
%systemd_postun_with_restart %{name}-api.service %{name}-metadata-api.service
%postun objectstore
%systemd_postun_with_restart %{name}-objectstore.service
%postun conductor
%systemd_postun_with_restart %{name}-conductor.service
%postun console
%systemd_postun_with_restart %{name}-console.service %{name}-consoleauth.service %{name}-xvpvncproxy.service
%postun cells
%systemd_postun_with_restart %{name}-cells.service
%postun novncproxy
%systemd_postun_with_restart %{name}-novncproxy.service
%postun spicehtml5proxy
%systemd_postun_with_restart %{name}-spicehtml5proxy.service
%postun serialproxy
%systemd_postun_with_restart %{name}-serialproxy.service

%files
%doc LICENSE
%{_bindir}/nova-all

%files common
%doc LICENSE
%dir %{_sysconfdir}/nova
%{_sysconfdir}/nova/release
%attr(-, root, nova) %{_datadir}/nova/nova-dist.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/nova.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/api-paste.ini
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/rootwrap.conf
%config(noreplace) %attr(-, root, nova) %{_sysconfdir}/nova/policy.json
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-nova
%config(noreplace) %{_sysconfdir}/sudoers.d/nova
%config(noreplace) %{_sysconfdir}/polkit-1/localauthority/50-local.d/50-nova.pkla
%config(noreplace) %{_sysconfdir}/polkit-1/rules.d/50-nova.rules

%dir %attr(0750, nova, root) %{_localstatedir}/log/nova
%dir %attr(0755, nova, root) %{_localstatedir}/run/nova

%{_bindir}/nova-manage
%{_bindir}/nova-rootwrap
%{_bindir}/nova-rootwrap-daemon

%{_datarootdir}/nova
%{_mandir}/man1/nova*.1.gz

%defattr(-, nova, nova, -)
%dir %{_sharedstatedir}/nova
%dir %{_sharedstatedir}/nova/buckets
%dir %{_sharedstatedir}/nova/instances
%dir %{_sharedstatedir}/nova/keys
%dir %{_sharedstatedir}/nova/networks
%dir %{_sharedstatedir}/nova/tmp

%files compute
%{_bindir}/nova-compute
%{_bindir}/nova-idmapshift
%{_unitdir}/openstack-nova-compute.service
%{_datarootdir}/nova/rootwrap/compute.filters

%files network
%{_bindir}/nova-network
%{_bindir}/nova-dhcpbridge
%{_unitdir}/openstack-nova-network.service
%{_datarootdir}/nova/rootwrap/network.filters

%files scheduler
%{_bindir}/nova-scheduler
%{_unitdir}/openstack-nova-scheduler.service

%files cert
%{_bindir}/nova-cert
%{_unitdir}/openstack-nova-cert.service
%defattr(-, nova, nova, -)
%dir %{_sharedstatedir}/nova/CA/
%dir %{_sharedstatedir}/nova/CA/certs
%dir %{_sharedstatedir}/nova/CA/crl
%dir %{_sharedstatedir}/nova/CA/newcerts
%dir %{_sharedstatedir}/nova/CA/projects
%dir %{_sharedstatedir}/nova/CA/reqs
%{_sharedstatedir}/nova/CA/*.sh
%{_sharedstatedir}/nova/CA/openssl.cnf.tmpl
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/cacert.pem
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/crl.pem
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/index.txt
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/openssl.cnf
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/serial
%dir %attr(0750, -, -) %{_sharedstatedir}/nova/CA/private
%ghost %config(missingok,noreplace) %verify(not md5 size mtime) %{_sharedstatedir}/nova/CA/private/cakey.pem

%files api
%{_bindir}/nova-api*
%{_unitdir}/openstack-nova-*api.service
%{_datarootdir}/nova/rootwrap/api-metadata.filters

%files conductor
%{_bindir}/nova-conductor
%{_unitdir}/openstack-nova-conductor.service

%files objectstore
%{_bindir}/nova-objectstore
%{_unitdir}/openstack-nova-objectstore.service

%files console
%{_bindir}/nova-console*
%{_bindir}/nova-xvpvncproxy
%{_unitdir}/openstack-nova-console*.service
%{_unitdir}/openstack-nova-xvpvncproxy.service

%files cells
%{_bindir}/nova-cells
%{_unitdir}/openstack-nova-cells.service

%files novncproxy
%{_bindir}/nova-novncproxy
%{_unitdir}/openstack-nova-novncproxy.service
%config(noreplace) %{_sysconfdir}/sysconfig/openstack-nova-novncproxy

%files spicehtml5proxy
%{_bindir}/nova-spicehtml5proxy
%{_unitdir}/openstack-nova-spicehtml5proxy.service

%files serialproxy
%{_bindir}/nova-serialproxy
%{_unitdir}/openstack-nova-serialproxy.service

%files migration
%{_bindir}/nova-migration-wrapper
%config(noreplace) %{_sysconfdir}/sudoers.d/nova_migration
%dir %attr(0700, nova, nova) %{_sharedstatedir}/nova/.ssh
%attr(0600, nova, nova) %{_sharedstatedir}/nova/.ssh/config
%dir %{_sysconfdir}/nova/migration
%config(noreplace) %attr(0640, root, nova_migration) %{_sysconfdir}/nova/migration/authorized_keys
%config(noreplace) %attr(0600, nova, nova) %{_sysconfdir}/nova/migration/identity
%config(noreplace) %attr(0640, root, root) %{_sysconfdir}/nova/migration/rootwrap.conf
%dir %{_sysconfdir}/nova/migration/rootwrap.d
%config(noreplace) %attr(0640, root, root) %{_sysconfdir}/nova/migration/rootwrap.d/cold_migration.filters

%files -n python-nova
%doc LICENSE
%{python2_sitelib}/nova
%{python2_sitelib}/nova-*.egg-info

%if 0%{?with_doc}
%files doc
%doc LICENSE doc/build/html
%endif

%changelog
* Wed Jun 21 2017 melanie witt <melwitt@redhat.com> 1:12.0.6-15
- Raise DeviceNotFound detaching volume from persistent domain (rhbz#1425936)
- Fix wait for detach code to handle 'disk not found error' (rhbz#1425936)

* Fri Jun 02 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.6-14
- fix: unable to unshelve instances (rhbz#1413010)

* Fri May 12 2017 Alex Schultz <aschultz@redhat.com> 1:12.0.6-13
- Add package for Nova migration SSH config (rhbz#1449324)

* Mon Mar 27 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.6-12
- Don't apply multi-queue to SRIOV ports (rhbz#1430359)

* Thu Mar 09 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-11
- libvirt: Remove redundant bdm serial mangling and saving during swap_volume (rhbz#1363972)
- After migrate in-use volume the BDM information lost (rhbz#1417788 rhbz#1363972)
- libvirt: Use the mirror element to detect job completion (rhbz#1363974)
- libvirt: Mock is_job_complete in test_driver (rhbz#1363974)
- libvirt: Fix BlockDevice.wait_for_job when qemu reports no job (rhbz#1363974)
- Fix race condition bug during live_snapshot (rhbz#1363974)
- libvirt: remove version checks for block job handling (rhbz#1363972)
- migration volume failed for invalid type (rhbz#1419480)

* Wed Mar 08 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-10
- compute: Remove instance.uuid from detach call during local delete (rhbz#1365016)

* Tue Feb 14 2017 Vladik Romanovsky <vromanso@redhat.com> 1:12.0.6-9
- libvirt: set vlan tag for macvtap on SR-IOV VFs (rhbz#1413372)

* Tue Feb 07 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-8
- libvirt: workaround findmnt behaviour change (rhbz#1419045)

* Fri Feb 03 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-7
- libvirt: Limit destroying disks during cleanup to spawn (rhbz#1410362)

* Tue Jan 31 2017 Artom Lifshitz <alifshit@redhat.com> 1:12.0.6-6
- libvirt: avoid generating script with empty path (rhbz#1416881)

* Thu Jan 19 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-5
- Use stashed volume connector in _local_cleanup_bdm_volumes (rhbz#1365016)
- Add uuidsentinel test module (rhbz#1365016)

* Thu Jan 19 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-4
- Completed migrations are not "in progress" (rhbz#1403728)

* Thu Jan 05 2017 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-3
- Cleanup after any failed libvirt spawn (rhbz#1410362)

* Wed Dec 21 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.6-2
- libvirt: fix serial console not correctly defined after live-migration (rhbz#1387513)

* Wed Dec 07 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.6-1
- Update to 12.0.6 (rhbz#1402413)

* Wed Nov 23 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.5-9
- Allow block live migration of an instance with attached volumes (rhbz#1381965)

* Wed Nov 09 2016 Matthew Booth <mbooth@redhat.com> 1:12.0.5-8
- Add error handling for delete-volume API (rhbz#1390109)

* Mon Nov 07 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.5-7
- libvirt: fix incorrect host cpus giving to emulator threads when RT - rhbz#1357461

* Thu Nov 03 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.5-6
- libvirt: Split out resize_image logic from create_image (rhbz#1304485)

* Thu Nov 03 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.5-5
- Create image for suspended instance booted from volume (rhbz#1387617)

* Tue Nov 01 2016 Artom Lifshitz <alifshit@redhat.com> 1:12.0.5-4
- Send events to all relevant hosts if migrating (rhbz#1343372)

* Thu Oct 20 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.5-3
- libvirt: fix DiskSmallerThanImage when block migrate ephemerals - rhbz#1381534

* Mon Oct 17 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.5-2
- Do not try to backport when db has older object version (rhbz#1385486)

* Tue Oct 04 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.5-1
- Update to 12.0.5 - rhbz#1381466

* Fri Sep 23 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.4-16
- Add required conntrack-tools for Network constrol service - rhbz#1378846

* Wed Sep 21 2016 Diana Clarke <dclarke@redhat.com> 1:12.0.4-15
- libvirt: use native AIO mode for cinder volumes - rhbz#1373613
- libvirt: use native AIO mode for image backends - rhbz#1373613

* Thu Sep 15 2016 Diana Clarke <dclarke@redhat.com> 1:12.0.4-14
- Remove paramiko dependency - rhbz#1373554

* Wed Sep 14 2016 Prateek Arora <parora@redhat.com> 1:12.0.4-13.el7
- Don't overwrite config disk when using Rbd - rhbz#1353498

* Wed Sep 14 2016 Prateek Arora <parora@redhat.com> 1:12.0.4-12.el7
- libvirt: Fix content of "disk.config" lost after migrate/resize - rhbz#1353498

* Wed Sep 14 2016 Prateek Arora <parora@redhat.com> 1:12.0.4-11.el7
- Remove fake_imagebackend.Raw and cleanup dependent tests-rhbz#1353498

* Wed Sep 14 2016 Prateek Arora <parora@redhat.com> 1:12.0.4-10.el7
- Only attempt to inject files if the injection disk exists-rhbz#1353498

* Tue Sep 13 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.4-9
- Fix NUMATopologyFilter error when hosts do not provide huge pages (rhbz#1369511)

* Thu Aug 18 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.4-8
- network: handle unauthorized exception from neutron (rhbz#1349863)

* Wed Aug 17 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.4-7
- compute: Skip driver detach calls for non local instances (rhbz#1339932)

* Thu Aug 04 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.4-6
- Fix multipath iSCSI encrypted volume attach failure (rhbz#1362514)

* Tue Jul 12 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.4-5
- Add reserved huge pages size capability for compute nodes - rhbz#1300680

* Tue Jul 05 2016 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1:12.0.4-4
- scheduler: quick-fail on CPUs pinning conflicts during migration - rhbz#1342592
- SameHostFilter should fail if host does not have instances - rhbz#1350356

* Wed Jun 22 2016 Dan Smith <dansmith@redhat.com> 1:12.0.4-3
- Update instance host in post live migration even when exception occurs - rhbz#1344947

* Thu Jun 16 2016 Michal Pryc <mpryc@redhat.com> 1:12.0.4-2
- Change .service perms from 755 to 644 to prevent log warnings - rhbz#1337178

* Thu Jun 09 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.4-1
- Update to 12.0.4 - rhbz#1344304

* Fri Jun 03 2016 Kashyap Chamarthy <kchamart@redhat.com> 1:12.0.3-11
- stop setting mtu when plugging vhost-user ports - rhbz#1337993

* Fri Jun 03 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.3-10
- Add missing compute libvirtd.service dependancy - rhbz#1340319

* Wed Jun 01 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.3-9
- Fix serial ports lost after hard-reboot - rhbz#1341606

* Fri May 27 2016 Artom Lifshitz <alifshit@redhat.com> 1:12.0.3-8
- Make compute rpcapi 'live_migration' backward compatible

* Fri May 27 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.3-7
- Ironic: Workaround to mitigate bug #1341420 (rhbz#1257950)
- Clean up networks with SR-IOV binding on reschedule
- SR-IOV: Improve the vnic type check in the neutron api

* Fri May 20 2016 Matthew Booth <mbooth@redhat.com> 1:12.0.3-6
- Fix migration-list --status - rhbz#1334607

* Wed May 18 2016 Kashyap Chamarthy <kchamart@redhat.com> 1:12.0.3-5
- compute: Retain instance metadata for 'evacuate' on shared storage - rhbz#1333132

* Wed May 18 2016 Diana Clarke <dclarke@redhat.com> 1:12.0.3-4
- VMware: Use Port Group and Key in binding details - rhbz#1329018
- Better support to force_raw_images setting - rhbz#1316147

* Fri May 13 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.3-3
- Fix repetition of start/stop causes serial console port exhaustion - rhbz#133259

* Tue May 03 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.3-2
- Handle port security disabled option for networks - rhbz#1331418

* Fri Apr 15 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.3-1
- Update to 12.0.3 - rhbz#1325953

* Thu Apr 14 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.2-6
- Fix conversion of config disks to qcow2 during resize/migration - rhbz#1314031
- libvirt: Comment non-obvious security implications of migrate code - rhbz#1314031
- libvirt: Fix resize of instance with deleted glance image - rhbz#1314031

* Fri Apr 01 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.2-5
- rbd: use rbd snapshots and cloning for ephemeral disk snapshots - rhbz#1311314

* Tue Mar 22 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.2-4
- Provide correct connector for evacuate terminate - rhbz#1317519
- Rollback is needed if initialize_connection times out - rhbz#1317519

* Tue Mar 22 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.2-3
- Revert option to reserve hugepages on compute nodes - rhbz#1300680

* Thu Mar 10 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.2-2
- Fix processing of libvirt disk.info in non-disk-image cases - rhbz#1312924

* Tue Mar 08 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.2-1
- Update to 12.0.2 - rhbz#1315394

* Thu Mar 03 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.1-8
- libvirt: Always copy or recreate disk.info during a migration - rhbz#1312924

* Thu Mar 03 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.1-7
- Add retry logic for detaching device using LibVirt - rhbz#1310861

* Thu Feb 25 2016 Michal Pryc <mpryc@redhat.com> 1:12.0.1-6
- Added DROP-IN-RPM keyword to allow patches to be skipped.

* Thu Feb 18 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.1-6
- Provide option to reserve hugepages on compute nodes - rhbz#1300680

* Wed Feb 17 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.1-5
- Fix instance not destroyed after successful evacuation - rhbz#1301914

* Tue Feb 16 2016 Sahid Ferdjaoui <sferdjao@redhat.com> 1:12.0.1-4
- Add realtime vCPUs feature for guests - rhbz#1278174

* Mon Feb 08 2016 Sven Anderson <sven@redhat.com> 1:12.0.1-3
- Remove .po/.pot files from package - rhbz#1295785

* Mon Jan 25 2016 Michal Pryc <mpryc@redhat.com> 1:12.0.1-2
- Fix CPU pinning for odd number of CPUs w hyperthreading - rhbz#1298825
- hardware: stop using instance cell topology in CPU pinning logic - rhbz#1298825
- Revert "Store correct VirtCPUTopology" - rhbz#1298825

* Wed Jan 20 2016 Lee Yarwood <lyarwood@redhat.com> 1:12.0.1-1
- Update to 12.0.1 - rhbz#1293607

* Tue Jan 19 2016 Eoghan Glynn <eglynn@redhat.com> 1:12.0.0-7
- Fix nova 'vendor' definition, impacting subscription management - rhbz#1299821

* Wed Jan 13 2016 Sven Anderson <sven@redhat.com> 1:12.0.0-6
- Add 'copytruncate' to logrotate configuration - rhbz#1297010

* Wed Jan 13 2016 Matthew Booth <mbooth@redhat.com> 1:12.0.0-5
- Fix unprivileged API user can exfiltrate compute host data with instance
  snapshot - CVE-2015-7548

* Fri Dec 11 2015 Lee Yarwood <lyarwood@redhat.com> 1:12.0.0-4
- Add dependencies for sg3_utils and sysfsutils to nova-compute - rhbz#1288137

* Thu Dec 03 2015 Lee Yarwood <lyarwood@redhat.com> 1:12.0.0-3
- Fix attibute error when cloning raw images in Ceph - rhbz#1286411

* Wed Nov 11 2015 Alan Pevec <alan.pevec@redhat.com> 1:12.0.0-2
- Generate nova.conf.sample and update dependencies
- Drop MySQL-python dependency

* Sat Oct 17 2015 Alan Pevec <alan.pevec@redhat.com> 1:12.0.0-1
- Update to 12.0.0

* Fri Oct 09 2015 Alan Pevec <alan.pevec@redhat.com> 1:12.0.0-0.2.0rc2
- Update to upstream 12.0.0.0rc2

* Tue Sep 29 2015 Alan Pevec <alan.pevec@redhat.com> 12.0.0-0.1.0rc1
- OpenStack Liberty release candidate
